/*
 * This file was generated by the CommonAPI Generators.
 * Used org.genivi.commonapi.someip 3.2.0.v202012010944.
 * Used org.franca.core 0.13.1.201807231814.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
 * If a copy of the MPL was not distributed with this file, You can obtain one at
 * http://mozilla.org/MPL/2.0/.
 */
#ifndef V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_MANAGER_SOMEIP_PROXY_HPP_
#define V1_COMMONAPI_TELUX_CV2X_CV2X_RADIO_MANAGER_SOMEIP_PROXY_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioManagerProxyBase.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPProxy.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesSomeIPDeployment.hpp>
#include <v1/commonapi/telux/common/CommonDefinesSomeIPDeployment.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/SomeIP/Factory.hpp>
#include <CommonAPI/SomeIP/Proxy.hpp>
#include <CommonAPI/SomeIP/Types.hpp>
#include <CommonAPI/SomeIP/Event.hpp>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <string>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

class Cv2xRadioManagerSomeIPProxy
    : virtual public Cv2xRadioManagerProxyBase,
      virtual public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesSomeIPProxy {
public:
    Cv2xRadioManagerSomeIPProxy(
        const CommonAPI::SomeIP::Address &_address,
        const std::shared_ptr<CommonAPI::SomeIP::ProxyConnection> &_connection);

    virtual ~Cv2xRadioManagerSomeIPProxy();

    virtual CurrentCv2xStatusEvent& getCurrentCv2xStatusEvent();

    virtual void GetServiceStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus &_status, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> GetServiceStatusAsync(GetServiceStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void startCv2x(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::Status &_status, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> startCv2xAsync(StartCv2xAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void stopCv2x(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::Status &_status, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> stopCv2xAsync(StopCv2xAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void requestCv2xStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> requestCv2xStatusAsync(RequestCv2xStatusAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void requestCv2xStatusEx(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx, const CommonAPI::CallInfo *_info);

    virtual std::future<CommonAPI::CallStatus> requestCv2xStatusExAsync(RequestCv2xStatusExAsyncCallback _callback, const CommonAPI::CallInfo *_info);

    virtual void getOwnVersion(uint16_t &_major, uint16_t &_minor) const;

    virtual std::future<void> getCompletionFuture();

private:
    CommonAPI::SomeIP::Event<CurrentCv2xStatusEvent, CommonAPI::Deployable< ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes_::Cv2xStatusDeployment_t >> currentCv2xStatus_;

    std::promise<void> completed_;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_SOMEIP_PROXY_HPP_
